Index: src/Actions/Action.cpp
===================================================================
--- src/Actions/Action.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Action.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -174,5 +174,7 @@
     Dialog* dialog = createDialog();
     if (dialog->hasQueries()) {
-      dialog->display();
+      if (!dialog->display())
+        // dialog error or aborted -> throw exception
+        throw ActionFailureException() << ActionNameString(getName());
     }
     delete(dialog);
@@ -181,5 +183,5 @@
 //  try {
     startTimer();
-    getParametersfromValueStorage();
+    //getParametersfromValueStorage();
     state = performCall();
     endTimer();
Index: src/Actions/Action.hpp
===================================================================
--- src/Actions/Action.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Action.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -17,9 +17,11 @@
 #include <boost/shared_ptr.hpp>
 
+#include <boost/preprocessor/list/adt.hpp>
+
 /** Used in .def files in paramdefaults define to set that no default value exists.
- * We define NODEFAULT here, as it is used in .def files and needs to be present
+ * We define NOPARAM_DEFAULT here, as it is used in .def files and needs to be present
  * before these are included.
  */
-#define NODEFAULT ""
+#define NOPARAM_DEFAULT BOOST_PP_NIL
 
 // forward declaration
@@ -185,5 +187,5 @@
 
   /**
-   * This method is called by the Histor, when a redo is performed. It is
+   * This method is called by the History, when a redo is performed. It is
    * provided with the corresponding state produced by the undo method and
    * needs to produce a State that can then be used for another undo.
@@ -192,7 +194,7 @@
 
   /**
-   * This special state can be used to indicate that the Action was successfull
+   * This special state can be used to indicate that the Action was successful
    * without providing a special state. Use this if your Action does not need
-   * a speciallized state.
+   * a specialized state.
    */
   static state_ptr success;
@@ -200,5 +202,5 @@
   /**
    * This special state can be returned, to indicate that the action could not do it's
-   * work, was abborted by the user etc. If you return this state make sure to transactionize
+   * work, was aborted by the user etc. If you return this state make sure to transactionize
    * your Actions and unroll the complete transaction before this is returned.
    */
@@ -227,5 +229,5 @@
    * necessary ActionParameters by retrieving the values from ValueStorage.
    */
-  virtual void getParametersfromValueStorage()=0;
+  //virtual void getParametersfromValueStorage()=0;
 
   /**
@@ -268,5 +270,5 @@
  * It is implementing a memento pattern. The base class is completely empty,
  * since no general state internals can be given. The Action performing
- * the Undo should downcast to the apropriate type.
+ * the Undo should downcast to the appropriate type.
  */
 class ActionState{
Index: src/Actions/ActionRegistry.cpp
===================================================================
--- src/Actions/ActionRegistry.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/ActionRegistry.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -34,4 +34,7 @@
 using namespace MoleCuilder;
 
+// static entities
+bool ActionRegistry::completely_instatiated = false;
+
 /** Constructor for class ActionRegistry.
  */
@@ -40,4 +43,5 @@
   //std::cout << "ActionRegistry::ActionRegistry() called, instance is " << this << "." << std::endl;
   fillRegistry();
+  completely_instatiated = true;
 }
 
Index: src/Actions/ActionRegistry.hpp
===================================================================
--- src/Actions/ActionRegistry.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/ActionRegistry.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -48,4 +48,11 @@
   int getLastPosition(const std::string &MenuName) const;
 
+  /** Static getter for the state of the registry.
+   *
+   * @return true - ActionRegistry's cstor has run through, false - else
+   */
+  static bool getCompletely_instatiated()
+  { return completely_instatiated; }
+
 private:
   ActionRegistry();
@@ -53,4 +60,7 @@
 
   void fillRegistry();
+
+  //!> this tells whether ActionRegistry has been completed instantiated.
+  static bool completely_instatiated;
 };
 
Index: src/Actions/Action_impl_header.hpp
===================================================================
--- src/Actions/Action_impl_header.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Action_impl_header.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -14,8 +14,11 @@
 #include <boost/preprocessor/comparison/equal.hpp>
 #include <boost/preprocessor/comparison/not_equal.hpp>
+#include <boost/preprocessor/control/expr_if.hpp>
 #include <boost/preprocessor/control/if.hpp>
 #include <boost/preprocessor/debug/assert.hpp>
 #include <boost/preprocessor/iteration/local.hpp>
+#include <boost/preprocessor/list/adt.hpp>
 #include <boost/preprocessor/punctuation/comma_if.hpp>
+#include <boost/preprocessor/punctuation/paren.hpp>
 #include <boost/preprocessor/repetition/repeat.hpp>
 #include <boost/preprocessor/seq/elem.hpp>
@@ -31,4 +34,6 @@
 #include "Actions/ValueStorage.hpp"
 
+#include "Parameters/Parameter.hpp"
+
 // some derived names: if CATEGORY is not given, we don't prefix with it
 #ifdef CATEGORY
@@ -47,4 +52,15 @@
 #define MAXPARAMTYPES BOOST_PP_SEQ_SIZE(paramtypes)
 #endif
+#ifndef paramdefaults
+#define MAXPARAMDEFAULTS 0
+// this is required for valid_print "else part"
+#define sequencer(z,n,data) \
+  BOOST_PP_SEQ_PUSH_BACK( data, NOPARAM_DEFAULT)
+#define paramdefaults BOOST_PP_REPEAT( MAXPARAMTYPES, sequencer, BOOST_PP_SEQ_NIL )
+#else
+#define MAXPARAMDEFAULTS BOOST_PP_SEQ_SIZE(paramdefaults)
+#endif
+#define PARAM_DEFAULT(x) \
+    (x, BOOST_PP_NIL)
 
 // check user has given name and category
@@ -77,11 +93,11 @@
 #endif
 
-// check if paramdefaults is given, otherwise fill list with NODEFAULT
+// check if paramdefaults is given, otherwise fill list with NOPARAM_DEFAULT
 // this does not work: paramdefaults has to be completely defined before
 // being used within option_print (used as an array there and not as
 // some function call still to be expanded)
-//#define paramdefaults (NODEFAULT)
+//#define paramdefaults (NOPARAM_DEFAULT)
 //#define tempvalue(z,n,value)
-//  BOOST_PP_CAT(value,(NODEFAULT))
+//  BOOST_PP_CAT(value,(NOPARAM_DEFAULT))
 //BOOST_PP_REPEAT(tempvalue, MAXPARAMTYPES, paramdefaults)
 //#undef tempvalue
@@ -95,8 +111,10 @@
 #endif
 
-// print a list of type ref followed by a separator, i.e. "int i;"
+// print a list of type ref followed by a separator, i.e. "Parameter<int> i;"
 #define type_print(z,n,TYPELIST, VARLIST, separator) \
+  Parameter < \
   BOOST_PP_SEQ_ELEM(n, TYPELIST) \
-  BOOST_PP_SEQ_ELEM(n, VARLIST)\
+  > \
+  BOOST_PP_SEQ_ELEM(n, VARLIST) \
   separator
 
@@ -108,5 +126,4 @@
 
 // prints Options.insert
-#ifdef paramdefaults
 #define option_print(z,n,unused, unused2) \
   tester = Options. insert (\
@@ -116,23 +133,15 @@
           BOOST_PP_SEQ_ELEM(n, paramtokens), \
           &typeid( BOOST_PP_SEQ_ELEM(n, paramtypes) ), \
-          BOOST_PP_SEQ_ELEM(n, paramdescriptions), \
-          std::string( BOOST_PP_SEQ_ELEM(n, paramdefaults) ) )\
+          BOOST_PP_SEQ_ELEM(n, paramdescriptions) \
+          BOOST_PP_COMMA_IF( BOOST_PP_NOT( BOOST_PP_LIST_IS_NIL( BOOST_PP_SEQ_ELEM(n, paramdefaults) ) ) ) \
+          BOOST_PP_EXPR_IF( \
+              BOOST_PP_NOT( BOOST_PP_LIST_IS_NIL( BOOST_PP_SEQ_ELEM(n, paramdefaults) ) ), \
+              toString BOOST_PP_LPAREN() \
+                  BOOST_PP_LIST_FIRST( BOOST_PP_SEQ_ELEM(n, paramdefaults) )) \
+              BOOST_PP_RPAREN() \
+          )\
       )\
   ); \
   ASSERT(tester.second, "ActionTrait<ACTION>::ActionTrait<ACTION>() option token present twice!");
-#else
-#define option_print(z,n,unused, unused2) \
-  tester = Options. insert (\
-      std::pair< std::string, OptionTrait *> ( \
-      BOOST_PP_SEQ_ELEM(n, paramtokens), \
-      new OptionTrait(\
-          BOOST_PP_SEQ_ELEM(n, paramtokens), \
-          &typeid( BOOST_PP_SEQ_ELEM(n, paramtypes) ), \
-          BOOST_PP_SEQ_ELEM(n, paramdescriptions), \
-          NODEFAULT )\
-      )\
-  ); \
-  ASSERT(tester.second, "ActionTrait<ACTION>::ActionTrait<ACTION>() option token present twice!");
-#endif
 
 namespace MoleCuilder {
@@ -205,4 +214,8 @@
 
   struct PARAMS : ActionParameters {
+    //!> constructor for class PARAMS, setting valid ranges
+    PARAMS();
+    //!> copy constructor for class PARAMS, setting valid ranges
+    PARAMS(const PARAMS &p);
   #if defined paramtypes && defined paramreferences
   #define BOOST_PP_LOCAL_MACRO(n) type_print(~, n, paramtypes, paramreferences, ;)
@@ -219,5 +232,5 @@
 
 private:
-  virtual void getParametersfromValueStorage();
+  //virtual void getParametersfromValueStorage();
   virtual Action::state_ptr performCall();
   virtual Action::state_ptr performUndo(Action::state_ptr);
@@ -227,4 +240,5 @@
 }
 
+#undef paramvalids
 #undef paramtypes
 #undef paramtokens
@@ -233,9 +247,12 @@
 #undef paramdefaults
 #undef MAXPARAMTYPES
+#undef MAXPARAMDEFAULTS
 #undef statetypes
 #undef statereferences
 #undef MAXSTATETYPES
+#undef PARAM_DEFAULT
 
 #undef option_print
+#undef sequencer
 #undef type_print
 #undef type_list
Index: src/Actions/Action_impl_pre.hpp
===================================================================
--- src/Actions/Action_impl_pre.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Action_impl_pre.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -37,7 +37,9 @@
 #include <boost/preprocessor/comparison/equal.hpp>
 #include <boost/preprocessor/comparison/not_equal.hpp>
+#include <boost/preprocessor/control/expr_if.hpp>
 #include <boost/preprocessor/control/if.hpp>
 #include <boost/preprocessor/debug/assert.hpp>
 #include <boost/preprocessor/iteration/local.hpp>
+#include <boost/preprocessor/list/adt.hpp>
 #include <boost/preprocessor/punctuation/comma_if.hpp>
 #include <boost/preprocessor/repetition/repeat.hpp>
@@ -48,4 +50,7 @@
 #include <boost/preprocessor/seq/transform.hpp>
 
+#include "Parameters/Parameter.hpp"
+
+
 // some derived names: if CATEGORY is not given, we don't prefix with it
 #ifdef CATEGORY
@@ -73,4 +78,15 @@
 #define MAXSTATETYPES BOOST_PP_SEQ_SIZE(statetypes)
 #endif
+#ifndef paramdefaults
+#define MAXPARAMDEFAULTS 0
+// this is required for valid_print "else part"
+#define sequencer(z,n,data) \
+  BOOST_PP_SEQ_PUSH_BACK( data, NOPARAM_DEFAULT)
+#define paramdefaults BOOST_PP_REPEAT( MAXPARAMTYPES, sequencer, BOOST_PP_SEQ_NIL )
+#else
+#define MAXPARAMDEFAULTS BOOST_PP_SEQ_SIZE(paramdefaults)
+#endif
+#define PARAM_DEFAULT(x) \
+    (x, BOOST_PP_NIL)
 
 // check user has given name and category
@@ -118,27 +134,48 @@
   dialog->query<\
   BOOST_PP_SEQ_ELEM(n, paramtypes)\
-  >(\
+  >( params. \
+  BOOST_PP_SEQ_ELEM(n, paramreferences)\
+  ,\
   BOOST_PP_SEQ_ELEM(n, paramtokens)\
   , Traits.getDescription()\
   );
 
+// print an initialiser list, i.e. "var( token, valid (,default) )(,)"
+#define valid_print(z,n,TOKENLIST, VARLIST, VALIDLIST, DEFAULTLIST) \
+  BOOST_PP_COMMA_IF(n) \
+  BOOST_PP_SEQ_ELEM(n, VARLIST) \
+  ( \
+  BOOST_PP_SEQ_ELEM(n, TOKENLIST) \
+  , \
+  BOOST_PP_SEQ_ELEM(n, VALIDLIST) \
+  BOOST_PP_COMMA_IF( BOOST_PP_NOT( BOOST_PP_LIST_IS_NIL( BOOST_PP_SEQ_ELEM(n, DEFAULTLIST) ) ) ) \
+  BOOST_PP_EXPR_IF( \
+      BOOST_PP_NOT( BOOST_PP_LIST_IS_NIL( BOOST_PP_SEQ_ELEM(n, DEFAULTLIST) ) ), \
+      BOOST_PP_LIST_FIRST( BOOST_PP_SEQ_ELEM(n, DEFAULTLIST) )) \
+  )
+
+// print an initialiser list, i.e. "var( valid . var )(,)"
+#define validcopy_print(z,n,TOKENLIST, VARLIST, VALID) \
+  BOOST_PP_COMMA_IF(n) \
+  BOOST_PP_SEQ_ELEM(n, VARLIST) \
+  ( \
+  VALID . \
+  BOOST_PP_SEQ_ELEM(n, VARLIST) \
+  )
+
 // prints set/queryCurrentValue (command) for paramreferences and paramtokens
-#define value_print(z,n,command, prefix) \
-  ValueStorage::getInstance(). command (\
-  BOOST_PP_SEQ_ELEM(n, paramtokens)\
-  , \
-  prefix\
-  BOOST_PP_SEQ_ELEM(n, paramreferences)\
+#define value_print(z, n, container, prefix) \
+  prefix \
+  BOOST_PP_SEQ_ELEM(n, container)\
+  .set(\
+  BOOST_PP_SEQ_ELEM(n, container)\
   );
 
 // prints set/queryCurrentValue (command) for paramreferences and paramtokens
-#define valuetype_print(z,n,command, prefix) \
-  ValueStorage::getInstance(). command< \
-  BOOST_PP_SEQ_ELEM(n, paramtypes) \
-  > (\
-  BOOST_PP_SEQ_ELEM(n, paramtokens)\
-  , \
-  prefix\
-  BOOST_PP_SEQ_ELEM(n, paramreferences)\
+#define valuetype_print(z,n,container, types, prefix) \
+  prefix \
+  BOOST_PP_SEQ_ELEM(n, container) \
+  .setAsString( \
+  BOOST_PP_SEQ_ELEM(n, container) \
   );
 
@@ -206,4 +243,23 @@
 }
 
+// =========== parameter constructor ===========
+ACTION::PARAMS::PARAMS()
+#if defined paramtokens && defined paramreferences && defined paramvalids
+      :
+#define BOOST_PP_LOCAL_MACRO(n) valid_print(~, n, paramtokens, paramreferences, paramvalids, paramdefaults)
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+#endif
+    {}
+
+ACTION::PARAMS::PARAMS(const PARAMS &p)
+#if defined paramtokens && defined paramreferences
+      :
+#define BOOST_PP_LOCAL_MACRO(n) validcopy_print(~, n, paramtokens, paramreferences, p)
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+#endif
+    {}
+
 // =========== fill a dialog ===========
 Dialog* ACTION::fillDialog(Dialog *dialog) {
@@ -226,5 +282,5 @@
 // =========== command for calling action directly ===========
 void COMMAND(
-#if defined paramtypes && defined paramreferences
+#if defined paramtypes && defined paramreferences && BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
 #define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, paramtypes, paramreferences)
 #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
@@ -233,8 +289,8 @@
 )
 {
-  Action *ToCall = ActionRegistry::getInstance().getActionByName( TOKEN ); //->clone(params);
+  ACTION *ToCall = dynamic_cast<ACTION*>(ActionRegistry::getInstance().getActionByName( TOKEN )); //->clone(params);
   //ACTION::PARAMS params;
-#if BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
-#define BOOST_PP_LOCAL_MACRO(n) value_print(~, n, setCurrentValue, )
+#if defined paramreferences && BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
+#define BOOST_PP_LOCAL_MACRO(n) value_print(~, n, paramreferences, ToCall->params.)
 #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
 #include BOOST_PP_LOCAL_ITERATE()
@@ -244,5 +300,5 @@
 
 void BOOST_PP_CAT( COMMAND, _stringargs)(
-#if defined paramtypes && defined paramreferences
+#if defined paramtypes && defined paramreferences && BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
 #define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, BOOST_PP_SEQ_TRANSFORM( type2string, , paramtypes), paramreferences)
 #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
@@ -250,8 +306,8 @@
 #endif
 	) {
-  Action *ToCall = ActionRegistry::getInstance().getActionByName( TOKEN ); //->clone(params);
+  ACTION *ToCall = dynamic_cast<ACTION*>(ActionRegistry::getInstance().getActionByName( TOKEN )); //->clone(params);
   //ACTION::PARAMS params;
-#if BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
-#define BOOST_PP_LOCAL_MACRO(n) valuetype_print(~, n, setCurrentValueByString, )
+#if defined paramtypes && defined paramtypes && BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
+#define BOOST_PP_LOCAL_MACRO(n) valuetype_print(~, n, paramreferences, paramtypes, ToCall->params. )
 #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
 #include BOOST_PP_LOCAL_ITERATE()
@@ -260,23 +316,19 @@
 };
 
-// =========== obtain parameters from Storage, used by performCall() ===========
-void ACTION::getParametersfromValueStorage() {
-#if BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
-#define BOOST_PP_LOCAL_MACRO(n) value_print(~, n, queryCurrentValue, params.)
-#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
-#include BOOST_PP_LOCAL_ITERATE()
-#endif
-};
-
 }
 
 // free up defines
+#undef paramvalids
 #undef paramtypes
 #undef paramtokens
 #undef paramreferences
+#undef paramdescriptions
+#undef paramdefaults
 #undef MAXPARAMTYPES
+#undef MAXPARAMDEFAULTS
 #undef statetypes
 #undef statereferences
 #undef MAXSTATETYPES
+#undef PARAM_DEFAULT
 
 #undef type2string
@@ -286,4 +338,7 @@
 #undef type_list
 #undef dialog_print
+#undef sequencer
+#undef valid_print
+#undef validcopy_print
 #undef value_print
 #undef valuetype_print
Index: src/Actions/Action_impl_python.hpp
===================================================================
--- src/Actions/Action_impl_python.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Action_impl_python.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -18,7 +18,7 @@
 #include <boost/preprocessor/facilities/expand.hpp>
 #include <boost/preprocessor/iteration/local.hpp>
+#include <boost/preprocessor/list/adt.hpp>
 #include <boost/preprocessor/punctuation/comma_if.hpp>
-
-#define NODEFAULT ""
+#include <boost/preprocessor/punctuation/paren.hpp>
 
 // some derived names: if CATEGORY is not given, we don't prefix with it
@@ -32,4 +32,8 @@
 #define PARAMS BOOST_PP_CAT(ACTIONNAME, Parameters)
 #endif
+
+// for paramdefaults entries
+#define PARAM_DEFAULT(x) \
+    (x, BOOST_PP_NIL)
 
 // check if no lists given
@@ -61,5 +65,12 @@
   BOOST_PP_SEQ_ELEM(n, STRINGLIST) \
   ) \
-  = BOOST_PP_SEQ_ELEM(n, DEFAULTLIST)
+  = \
+  BOOST_PP_IF( \
+      BOOST_PP_NOT( BOOST_PP_LIST_IS_NIL( BOOST_PP_SEQ_ELEM(n, paramdefaults) ) ), \
+      toString BOOST_PP_LPAREN() \
+          BOOST_PP_LIST_FIRST( BOOST_PP_SEQ_ELEM(n, DEFAULTLIST) ) \
+      BOOST_PP_RPAREN(), \
+      std::string("") \
+  )
 
 // print a list of comma-separated list, i.e. (,)arg("Action")
@@ -142,4 +153,5 @@
 #undef PARAMS
 #undef MAXPARAMTYPES
+#undef PARAM_DEFAULT
 
 #undef help_print
Index: src/Actions/Action_impl_undef.hpp
===================================================================
--- src/Actions/Action_impl_undef.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Action_impl_undef.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -11,9 +11,10 @@
 #endif
 
+#undef paramvalids
 #undef paramtypes
 #undef paramtokens
+#undef paramreferences
 #undef paramdescriptions
 #undef paramdefaults
-#undef paramreferences
 
 #undef statetypes
Index: src/Actions/AnalysisAction/CalculateBoundingBoxAction.def
===================================================================
--- src/Actions/AnalysisAction/CalculateBoundingBoxAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/CalculateBoundingBoxAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,7 +10,9 @@
 typedef std::vector<double> doubleVec;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
@@ -18,4 +20,5 @@
 #undef paramdescriptions
 #undef paramdefaults
+#undef paramvalids
 
 // Reaction cannot be undone, hence no state
Index: src/Actions/AnalysisAction/CalculateCellVolumeAction.def
===================================================================
--- src/Actions/AnalysisAction/CalculateCellVolumeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/CalculateCellVolumeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
@@ -16,4 +18,5 @@
 #undef paramdescriptions
 #undef paramdefaults
+#undef paramvalids
 
 // Reaction cannot be undone, hence no state
Index: src/Actions/AnalysisAction/CalculateMolarMassAction.def
===================================================================
--- src/Actions/AnalysisAction/CalculateMolarMassAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/CalculateMolarMassAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
@@ -16,4 +18,5 @@
 #undef paramdescriptions
 #undef paramdefaults
+#undef paramvalids
 
 // Reaction cannot be undone, hence no state
Index: src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -56,6 +56,6 @@
 
   // select atoms and obtain zero dipole orientation
-  Formula DipoleFormula(params.DipoleFormula);
-  World::getInstance().setTime(params.timestepzero);
+  Formula DipoleFormula(params.DipoleFormula.get());
+  World::getInstance().setTime(params.timestepzero.get());
   World::getInstance().clearMoleculeSelection(); // TODO: This should be done in setTime or where molecules are re-done
   World::getInstance().selectAllMolecules(MoleculeByFormula(DipoleFormula));
@@ -71,9 +71,9 @@
       +toString(DipoleFormula)+" selects no atoms.");
   range<size_t> timesteps = getMaximumTrajectoryBounds(atoms);
-  ASSERT(params.timestepzero < timesteps.first,
+  ASSERT(params.timestepzero.get() < timesteps.first,
     "AnalysisDipoleAngularCorrelationAction::performCall() - time step zero "
-    +toString(params.timestepzero)+" is beyond trajectory range ("
+    +toString(params.timestepzero.get())+" is beyond trajectory range ("
     +toString(timesteps.first)+") of some atoms.");
-  for (size_t step = params.timestepzero; step < timesteps.first; ++step) {
+  for (size_t step = params.timestepzero.get(); step < timesteps.first; ++step) {
     // calculate dipoles relative to zero orientation
     DipoleAngularCorrelationMap *correlationmap = NULL;
@@ -87,5 +87,5 @@
     // output correlation map
     ofstream output;
-    std::string filename = params.outputname.string()+"."+stepname+".dat";
+    std::string filename = params.outputname.get().string()+"."+stepname+".dat";
     output.open(filename.c_str());
     OutputCorrelationMap<DipoleAngularCorrelationMap>(&output, correlationmap, OutputDipoleAngularCorrelation_Header, OutputDipoleAngularCorrelation_Value);
@@ -93,5 +93,5 @@
 
     // bin map
-    BinPairMap *binmap = BinData( correlationmap, params.BinWidth, params.BinStart, params.BinEnd );
+    BinPairMap *binmap = BinData( correlationmap, params.BinWidth.get(), params.BinStart.get(), params.BinEnd.get() );
 
     // free correlation map
@@ -100,5 +100,5 @@
     // output binned map
     ofstream binoutput;
-    std::string binfilename = params.binoutputname.string()+"."+stepname+".dat";
+    std::string binfilename = params.binoutputname.get().string()+"."+stepname+".dat";
     binoutput.open(binfilename.c_str());
     OutputCorrelationMap<BinPairMap> ( &binoutput, binmap, OutputCorrelation_Header, OutputCorrelation_Value );
Index: src/Actions/AnalysisAction/DipoleAngularCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/DipoleAngularCorrelationAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/DipoleAngularCorrelationAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,12 +10,27 @@
 #include <vector>
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/FormulaValidator.hpp"
+#include "Parameters/Validators/Specific/RotationAngleValidator.hpp"
+#include "Parameters/Validators/Specific/TimeStepPresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)(double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(unsigned int)
 #define paramreferences (DipoleFormula)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(timestepzero)
 #define paramtokens ("dipole-angular-correlation")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("time-step-zero")
 #define paramdescriptions ("formula of molecules to calculate dipole of")("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("initial time step to correlate following ones against")
-#define paramdefaults (NODEFAULT)(NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.5))(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0))
+#define paramvalids \
+(FormulaValidator()) \
+(RotationAngleValidator()) \
+(RotationAngleValidator()) \
+(RotationAngleValidator()) \
+(!FilePresentValidator()) \
+(!FilePresentValidator()) \
+(TimeStepPresentValidator())
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/AnalysisAction/DipoleCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/DipoleCorrelationAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/DipoleCorrelationAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -48,13 +48,13 @@
 
   // execute action
-  output.open(params.outputname.string().c_str());
-  binoutput.open(params.binoutputname.string().c_str());
+  output.open(params.outputname.get().string().c_str());
+  binoutput.open(params.binoutputname.get().string().c_str());
   DipoleCorrelationMap *correlationmap = NULL;
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
   LOG(0, "STATUS: There are " << molecules.size() << " selected molecules.");
-  ASSERT(!params.periodic, "AnalysisDipoleCorrelationAction() - periodic case not implemented.");
+  ASSERT(!params.periodic.get(), "AnalysisDipoleCorrelationAction() - periodic case not implemented.");
   correlationmap = DipoleCorrelation(molecules);
   OutputCorrelationMap<DipoleCorrelationMap>(&output, correlationmap, OutputDipoleCorrelation_Header, OutputDipoleCorrelation_Value);
-  binmap = BinData( correlationmap, params.BinWidth, params.BinStart, params.BinEnd );
+  binmap = BinData( correlationmap, params.BinWidth.get(), params.BinStart.get(), params.BinEnd.get() );
   OutputCorrelationMap<BinPairMap> ( &binoutput, binmap, OutputCorrelation_Header, OutputCorrelation_Value );
   delete(binmap);
Index: src/Actions/AnalysisAction/DipoleCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/DipoleCorrelationAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/DipoleCorrelationAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -10,12 +10,24 @@
 #include <vector>
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/RotationAngleValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
 #define paramreferences (BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
 #define paramtokens ("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
 #define paramdescriptions ("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
-#define paramdefaults (NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
+#define paramdefaults (NOPARAM_DEFAULT)(PARAM_DEFAULT(0.5))(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(false))
+#define paramvalids \
+(RotationAngleValidator()) \
+(RotationAngleValidator()) \
+(RotationAngleValidator()) \
+(!FilePresentValidator()) \
+(!FilePresentValidator()) \
+(DummyValidator<bool>())
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/AnalysisAction/MolecularVolumeAction.def
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
@@ -16,4 +18,5 @@
 #undef paramdescriptions
 #undef paramdefaults
+#undef paramvalids
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
